// 名前空間
var CHAT_DB = {};

// ios用
function callNativeApp(iosKey, jsonData) {
    console.log("callNativeApp called");
    var result;
    try {
        var key = iosKey;
        var data = jsonData;
        var payload = {key: key, data: data};
        // payloadの形 {"type":"SJbridge","data":{"name":"abc","role":"dev"}}
        // resにObjective-cからのレスポンスが返る
        result = prompt(JSON.stringify (payload));
        console.log(result);
    } catch(err) {
        console.log('The native context does not exist yet');
    }
    return result;
}


//ロカールDBからルーム一覧情報を取得
CHAT_DB.getRoomList = function(roomType, keyWord) {
    if (CHAT_UTIL.isIOS()) {

    } else if (CHAT_UTIL.isAndroid()) {
    	return JSON.parse(android.getRoomList(roomType, keyWord));
    }
};

CHAT_DB.callGetRoomList = function(roomType) {
    if (CHAT_UTIL.isIOS()) {
        return callNativeApp(getRoomList, {"roomType":roomType});
    } else if (CHAT_UTIL.isAndroid()) {
        //String形式をJsonに変更してReturn
    	return JSON.parse(android.getRoomList(roomType));
    }
}

//ロカールDBからログインしたユーザのデータを取得する。
CHAT_DB.getMyInfo = function() {
    if (CHAT_UTIL.isIOS()) {

    } else if (CHAT_UTIL.isAndroid()) {
        //String形式をJsonに変更してReturn
    	return JSON.parse(android.getMyInfo());
    }
};

CHAT_DB.getMessages = function(roomId) {
    if (CHAT_UTIL.isIOS()) {

    } else if (CHAT_UTIL.isAndroid()) {
        //String形式をJsonに変更してReturn
    	return JSON.parse(android.getMessageList(roomId));
    }
};

CHAT_DB.getFavoriteUsers = function() {
    if (CHAT_UTIL.isIOS()) {

    } else if (CHAT_UTIL.isAndroid()) {
        //String形式をJsonに変更してReturn
    	return JSON.parse(android.getFavoriteUsers());
    }
};

CHAT_DB.getFavoriteGroups = function() {
    if (CHAT_UTIL.isIOS()) {

    } else if (CHAT_UTIL.isAndroid()) {
        //String形式をJsonに変更してReturn
    	return JSON.parse(android.getFavoriteGroups());
    }
};

CHAT_DB.getMyGroupUsers = function() {
    if (CHAT_UTIL.isIOS()) {

    } else if (CHAT_UTIL.isAndroid()) {
        //String形式をJsonに変更してReturn
    	return JSON.parse(android.getMyGroupUsers());
    }
};

CHAT_DB.getGroupInfo = function(groupId) {
    if (CHAT_UTIL.isIOS()) {
        
    } else if (CHAT_UTIL.isAndroid()) {
        //String形式をJsonに変更してReturn
    	return JSON.parse(android.getGroupInfo(groupId));
    }
};

CHAT_DB.getNameCardData = function(shopMemberId) {
    if (CHAT_UTIL.isIOS()) {
        
    } else if (CHAT_UTIL.isAndroid()) {
    	return JSON.parse(android.getNameCardData(shopMemberId));
    }
};

CHAT_DB.getMyGroupShopMemberByName = function(shopMemberName) {
    if (CHAT_UTIL.isIOS()) {
        
    } else if (CHAT_UTIL.isAndroid()) {
        //String形式をJsonに変更してReturn
    	return JSON.parse(android.getMyGroupShopMemberByName(shopMemberName));
    }
};

CHAT_DB.getAllGroupShopMemberByName = function(shopMemberName) {
    if (CHAT_UTIL.isIOS()) {
        
    } else if (CHAT_UTIL.isAndroid()) {
        //String形式をJsonに変更してReturn
    	return JSON.parse(android.getAllGroupShopMemberByName(shopMemberName));
    }
};

CHAT_DB.getGroupByName = function(groupName) {
    if (CHAT_UTIL.isIOS()) {
        
    } else if (CHAT_UTIL.isAndroid()) {
        //String形式をJsonに変更してReturn
    	return JSON.parse(android.getGroupByName(groupName));
    }
};

CHAT_DB.getUsersInRoom = function(roomId) {
    if (CHAT_UTIL.isIOS()) {
        
    } else if (CHAT_UTIL.isAndroid()) {
        //String形式をJsonに変更してReturn
    	return JSON.parse(android.getUsersInRoom(roomId));
    }
}

// アーカイブ一覧
CHAT_DB.getArchiveList = function() {
    if (CHAT_UTIL.isIOS()) {
        iosArchiveList = "";
        webkit.messageHandlers.getArchiveList.postMessage();
        // JavascriptからObjective-cのメソッドを指定してコールバックを受ける方法がないため、
        // 値が入るまで待たせている。
        while (iosKey == "objc-processing") {};
        if (iosKey == "archiveList") {
            iosKey = "objc-processing";
            return JSON.parse(iosArchiveList);
        }
    } else if (CHAT_UTIL.isAndroid()) {
        // TODO
    }
};

CHAT_DB.getIosArchiveList = function(archiveList) {
    iosArchiveList = archiveList;
    iosKey = "archiveList";
};

CHAT_DB.updateArchiveList = function() {
    if (CHAT_UTIL.isIOS()) {
        webkit.messageHandlers.updateArchiveList.postMessage();
    } else if (CHAT_UTIL.isAndroid()) {
        // TODO
    }
};

// アーカイブ一覧検索
CHAT_DB.getArchiveByName = function(archiveName) {
    if (CHAT_UTIL.isIOS()) {
        iosSearchArchiveList = "";
        webkit.messageHandlers.getArchiveByName.postMessage({archiveName});
        // JavascriptからObjective-cのメソッドを指定してコールバックを受ける方法がないため、
        // 値が入るまで待たせている。
        while (iosKey == "objc-processing") {};
        if (iosKey == "searchArchiveList") {
            iosKey = "objc-processing";
            return JSON.parse(iosSearchArchiveList);
        }
    } else if (CHAT_UTIL.isAndroid()) {
        // TODO
    }
};

CHAT_DB.getIosSearchArchiveList = function(archiveList) {
    iosSearchArchiveList = archiveList;
    iosKey = "searchArchiveList";
};

// アーカイブ詳細
CHAT_DB.getArchiveDetail = function(archiveId) {
    if (CHAT_UTIL.isIOS()) {
        iosArchiveDetail = "";
        webkit.messageHandlers.getArchiveDetail.postMessage({archiveId});
        // JavascriptからObjective-cのメソッドを指定してコールバックを受ける方法がないため、
        // 値が入るまで待たせている。
        while (iosKey == "objc-processing") {};
        if (iosKey == "archiveDetail") {
            iosKey = "objc-processing";
            return JSON.parse(iosArchiveDetail);
        }
    } else if (CHAT_UTIL.isAndroid()) {
        // TODO
    }
};

CHAT_DB.getIosArchiveDetail = function(archiveDetail) {
    iosArchiveDetail = archiveDetail;
    iosKey = "archiveDetail";
};

CHAT_DB.updateArchiveDetail = function(archiveId) {
    if (CHAT_UTIL.isIOS()) {
        webkit.messageHandlers.updateArchiveDetail.postMessage({archiveId});
    } else if (CHAT_UTIL.isAndroid()) {
        // TODO
    }
};
